package com.yongqi.xinrenli.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.yongqi.xinrenli.domain.bo.DbOrderBo;
import com.yongqi.xinrenli.domain.vo.DbOrderVo;
import com.yongqi.xinrenli.domain.DbOrder;
import com.yongqi.xinrenli.mapper.DbOrderMapper;
import com.yongqi.xinrenli.service.IDbOrderService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 订单Service业务层处理
 *
 * @author zyf
 * @date 2023-03-09
 */
@RequiredArgsConstructor
@Service
public class DbOrderServiceImpl implements IDbOrderService {

    private final DbOrderMapper baseMapper;

    /**
     * 查询订单
     */
    @Override
    public DbOrderVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询订单列表
     */
    @Override
    public TableDataInfo<DbOrderVo> queryPageList(DbOrderBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<DbOrder> lqw = buildQueryWrapper(bo);
        Page<DbOrderVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询订单列表
     */
    @Override
    public List<DbOrderVo> queryList(DbOrderBo bo) {
        LambdaQueryWrapper<DbOrder> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<DbOrder> buildQueryWrapper(DbOrderBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<DbOrder> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUserId() != null, DbOrder::getUserId, bo.getUserId());
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), DbOrder::getTitle, bo.getTitle());
        lqw.eq(StringUtils.isNotBlank(bo.getLinkman()), DbOrder::getLinkman, bo.getLinkman());
        lqw.eq(StringUtils.isNotBlank(bo.getPhone()), DbOrder::getPhone, bo.getPhone());
        lqw.eq(bo.getRepairTime() != null, DbOrder::getRepairTime, bo.getRepairTime());
        lqw.eq(StringUtils.isNotBlank(bo.getRepairAddress()), DbOrder::getRepairAddress, bo.getRepairAddress());
        lqw.eq(bo.getBudget() != null, DbOrder::getBudget, bo.getBudget());
        lqw.eq(bo.getStatus() != null, DbOrder::getStatus, bo.getStatus());
        lqw.eq(StringUtils.isNotBlank(bo.getCreateUser()), DbOrder::getCreateUser, bo.getCreateUser());
        lqw.eq(StringUtils.isNotBlank(bo.getModifyUser()), DbOrder::getModifyUser, bo.getModifyUser());
        lqw.eq(bo.getModifyTime() != null, DbOrder::getModifyTime, bo.getModifyTime());
        lqw.eq(bo.getDeleteStatus() != null, DbOrder::getDeleteStatus, bo.getDeleteStatus());
        return lqw;
    }

    /**
     * 新增订单
     */
    @Override
    public Boolean insertByBo(DbOrderBo bo) {
        DbOrder add = BeanUtil.toBean(bo, DbOrder.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改订单
     */
    @Override
    public Boolean updateByBo(DbOrderBo bo) {
        DbOrder update = BeanUtil.toBean(bo, DbOrder.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(DbOrder entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除订单
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
